//+------------------------------------------------------------------+
//|                                        Stochastic4TFalligned.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  3
#property indicator_minimum -4
#property indicator_maximum  4
#property indicator_color1   DimGray
#property indicator_color2   Green
#property indicator_color3   Red
#property indicator_width2   2
#property indicator_width3   2

extern int    TimeFrame1 =  15;
extern int    TimeFrame2 =  30;
extern int    TimeFrame3 =  60;
extern int    TimeFrame4 = 240;
extern double LowLimit   =  20;
extern double HighLimit  =  80;

//
//
//
//
//

double bufferv[];
double bufferu[];
double bufferd[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferv);
   SetIndexBuffer(1,bufferu); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferd); SetIndexStyle(2,DRAW_HISTOGRAM);
   return(0);
}
int deinit() {                           return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      int result = 0;
          result += findState(TimeFrame1,i);
          result += findState(TimeFrame2,i);
          result += findState(TimeFrame3,i);
          result += findState(TimeFrame4,i);
      bufferv[i] = result;
      bufferu[i] = EMPTY_VALUE;
      bufferd[i] = EMPTY_VALUE;
         if (result==4)  bufferu[i] =  4;
         if (result==-4) bufferd[i] = -4;
   }
   
   return(0);
}

//
//
//
//
//

int findState(int trendTimeFrame,int pos)
{
   int i = iBarShift(NULL,trendTimeFrame,Time[pos]);
   double currStoch = iStochastic(NULL,trendTimeFrame,5,3,3,MODE_SMA,0,MODE_MAIN,1+i);
   double prevStoch = iStochastic(NULL,trendTimeFrame,5,3,3,MODE_SMA,0,MODE_MAIN,2+i);
   
   if ((currStoch >= LowLimit)  && (currStoch > prevStoch)) return( 1);
   if ((currStoch <= HighLimit) && (currStoch < prevStoch)) return(-1);
                                                            return( 0);
}